---------------------------------------------------------------------
-- debug.lua
--
-- Do not ship this file.  The game must run even if this file
-- does not exist.
---------------------------------------------------------------------

function toggle(b)
	if (b==1) then return 0 else return 1 end
end

omMakeCommand(COM_JETCHEAT,     "J",        CON_BUTTON_HELD, 0, 0)
omMakeCommand(COM_TURBO,        "T",        CON_BUTTON_FALL, 0, 0)

omMakeCommand(COM_LOOKLEFT,     ",",        CON_BUTTON_HELD, 0, 0)
omMakeCommand(COM_LOOKRIGHT,    ".",        CON_BUTTON_HELD, 0, 0)
omMakeAxis(AXIS_ORBITLEFTRIGHT, COM_LOOKLEFT, COM_LOOKRIGHT, 1, 0.001, 1, 1)

omMakeCommand(COM_CAMZOOMIN,    "NUM 9",    CON_BUTTON_HELD, 0, 0)
omMakeCommand(COM_CAMZOOMOUT,   "NUM 3",    CON_BUTTON_HELD, 0, 0)
omMakeCommand(COM_CAMENABLE,    "M",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_RAISEUP,      "NUM 0",    CON_BUTTON_HELD, 0, 0)
omMakeCommand(COM_RAISEDOWN,    "NUM DEL",  CON_BUTTON_HELD, 0, 0)

omMakeCommand(COM_DEBUGMENUTOG, "F9",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_CLEARCONSOLE, "F3",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SHOWSTATUS,   "F2",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SHOWBARS,     "F1",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SHOWBUMP,     "B",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SHOWMESH,     "M",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGHITCHECK,  "H",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_RANDOMIZE,    "R",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_EXECLAST,     "ENTER",    CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_PRINTCOL,     "L",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGL1,        "F5",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGL2,        "F6",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGL3,        "F7",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGL4,        "F8",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_TOGLG,        "F10",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_FREECAMERA,   "D",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SCENEGRAPH,   "S",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_ENABLESCRIPTS, "A",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_PRINTGOBSTATS, "Q",       CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_PRINTINFO,    "I",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_DEALDAMAGE,   "H",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_DEALMOREDAMAGE,"K",       CON_BUTTON_FALL, 0, 0)

omMakeCommand(COM_FASTFORWARD,  "0",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_SLOWMO,       "9",        CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MATRIXMODE,   "CTRL",     CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_BRIGHTNESS,   "DC2_HY",   CON_BUTTON_HELD, 0, 0)

omMakeCommand(COM_SCREENSHOT,   "Y",        CON_BUTTON_FALL, 0, 0)


comfuncs.game[COM_FASTFORWARD] = function()
    if (fastforward) then
        chForceDeltaT(0)
        fastforward = nil
    else
        chForceDeltaT(0.1)
        fastforward = 1
        slowmo = nil
    end
end

comfuncs.fkey[COM_SLOWMO] = function()
    if (slowmo) then
        chForceDeltaT(0)
        slowmo = nil
    else
        chForceDeltaT(0.01)
        slowmo = 1
        fastforward = nil
    end
end

comfuncs.game[COM_DEBUGMENUTOG] = function()
    gamecontrol.showmenu = 1
    if (omuClearConsole) then omuClearConsole() end
    newconscheme = "menu"
    menu.SwitchDlg("debug")
    mdkPauseGame(0)
end

comfuncs.menu[COM_DEBUGMENUTOG] = function()
    if (Level.file == "startscreen") then   -- cough cough.
        mdkPauseGame(0)
        gamecontrol.showmenu = 0
        newconscheme = "title"
    else
        mdkPauseGame(0)
        mdkHideCheckpointSnapshot()
        gamecontrol.showmenu = 0
        newconscheme = "game"
    end
end

comfuncs.fkey[COM_SHOWSTATUS] = function()
	scene.showstatus = toggle(scene.showstatus)
end

comfuncs.fkey[COM_SHOWBARS] = function()
	scene.showbars = toggle(scene.showbars)
end

comfuncs.game[COM_PRINTINFO] = function()
    local bob = mdkGetPlayerGob()
    if (bob) then
        print(format("( %.1f, %.1f, %.1f )  %.2f", bob.position.x, bob.position.y, bob.position.z, bob.orientation.yaw))
    end
end

comfuncs.game[COM_DEALDAMAGE] = function()
    local bob = mdkGetPlayerGob()
    if (bob) then
        mdkDealDamage(nil, bob, 5, DAMAGE_BADGUY, -1)
    end
end

comfuncs.game[COM_DEALMOREDAMAGE] = function()
    local bob = mdkGetPlayerGob()
    if (bob) then
        mdkDealDamage(nil, bob, 20, DAMAGE_BADGUY+DAMAGE_KNOCKDOWN, -1)
    end
end

$if 1
comfuncs.fkey[COM_CLEARCONSOLE] = omuClearConsole

comfuncs.game[COM_EXECLAST] = function()
	omuConsoleExecuteLastCommand()
end
$end

comfuncs.fkey[COM_SHOWBUMP] = function()
	scene.showbump = toggle(scene.showbump)
end

comfuncs.fkey[COM_SHOWMESH] = function()
	scene.showmesh = toggle(scene.showmesh)
end

comfuncs.fkey[COM_SCENEGRAPH] = function()
	showscenegraph = toggle(showscenegraph)
end

comfuncs.game[COM_RANDOMIZE] = function()
end

comfuncs.game[COM_PRINTGOBSTATS] = function()
	omPrintGobStats()
end


comfuncs.fkey[COM_FREECAMERA] = function()
    mdkTogglePlayerCameraCheat()
end


brightness = 1

comfuncs.fkey[COM_BRIGHTNESS] = function()

    brightness = brightness + 0.05
    chSetBrightness(brightness)

    if (brightness > 4.0) then 
        brightness = 0.5
    end 

end


--comfuncs.fkey[COM_TOGL1] = function()
--	luaToggleDefaultLight(1, 20, 20, 20)
--end
comfuncs.fkey[COM_TOGL2] = function()
	luaToggleDefaultLight(2,-20, 20, 20)
end
comfuncs.fkey[COM_TOGL3] = function()
	luaToggleDefaultLight(3,-20,-20, 20)
end
comfuncs.fkey[COM_TOGL4] = function()
	luaToggleDefaultLight(4, 20,-20, 20)
end
comfuncs.fkey[COM_TOGLG] = function()
	luaToggleGobLight()
end


comfuncs.fkey[COM_ENABLESCRIPTS] = function()
    local bob = mdkGetPlayerGob()
	if (mdkGetAITargetGob() == nil) then
		mdkSetAITargetGob(bob)
	else
		mdkSetAITargetGob(nil)
	end
end


function luaToggleDefaultLight(n, x, y, z)
    local lightname = "light"..tostring(n)
    local light = getglobal(lightname)
    if (light == nil) then
        light = omGobCreate(lightname)
        omGobAttach(scene, nil, light, -1)
        light.gl = omGobGLCreate()
        light.gl.radius = 100
		light.gl.intensity = 0.9
		light.gl.enabled = 1
        setglobal(lightname, light)
    else
        if (light.gl.enabled == 0) then
			light.gl.enabled = 1
        else
            light.gl.enabled = 0
        end
    end
	if (camera) then
		light.position = camera.position
	else
		VectorSet(light.position, x, y, z)
	end
end

function luaToggleGobLight()
end


function make(name, type)
	if (type==nil) then
		type = name
		name = ""
	end
    bob = mdkGetPlayerGob()
	local gob=mdkCreateObjectLua(name, type, scene, nil, nil, 0,0,0, 1,0,0,0, nil,0,0,0,0 )
	QuatYDir(gob.position, bob.orientation)
	VectorMul(gob.position, 6)
	VectorAdd(gob.position, bob.position)
end

function makes(name, mod)
	local gob=mdkCreateObjectLua(name, OBJ_SCENERY, scene, nil, nil, 0,0,0, 1,0,0,0, mod,0,0,0,0 )
    bob = mdkGetPlayerGob()
	if (bob) then
		QuatYDir(gob.position, bob.orientation)
		VectorMul(gob.position, 6)
		VectorAdd(gob.position, bob.position)
	end
end

function makesod(name, type, mod)
    bob = mdkGetPlayerGob()
	local gob=mdkCreateObjectLua(name, type, scene, nil, nil, 0,0,0, 1,0,0,0, mod,20,5,5,100 )
	QuatYDir(gob.position, bob.orientation)
	VectorMul(gob.position, 6)
	VectorAdd(gob.position, bob.position)
end


















--omBindCommand(COM_MOUSELEFT,	"MOUSEX-")
--omBindCommand(COM_MOUSERIGHT, "MOUSEX+")
--omBindCommand(COM_KBLEFT,		"Z")
--omBindCommand(COM_KBRIGHT,	"X")
--omBindCommand(COM_FORWARD,	"NUM 8")
--omBindCommand(COM_BACKWARD,	"NUM 2")
--omBindCommand(COM_LOOKUP,		"NUM 7")
--omBindCommand(COM_LOOKDOWN,	"NUM 1")
--omBindCommand(COM_MLOOKUP,	"MOUSEY-")
--omBindCommand(COM_MLOOKDOWN,	"MOUSEY+")
--omBindCommand(COM_STRAFELEFT, "NUM 4")
--omBindCommand(COM_STRAFERIGHT,"NUM 6")

function c1()
    -- Player/Camera Controls --
    omBindCommand(COM_MOUSELEFT,	"HX")
    omBindCommand(COM_MOUSERIGHT, "HX")
    omBindCommand(COM_MLOOKUP,	"HY")
    omBindCommand(COM_MLOOKDOWN,	"HY")

    omBindCommand(COM_FORWARD,	"Y")
    omBindCommand(COM_BACKWARD,	"A")

    omBindCommand(COM_STRAFELEFT, "X")
    omBindCommand(COM_STRAFERIGHT,"B")

    omBindCommand(COM_KJUMP,		"TLEFT")
    omBindCommand(COM_CHUTE,		"TLEFT")
    omBindCommand(COM_SHOOT,		"TRIGHT")
    omBindCommand(COM_JET,		"UP")
end

function c2()
    -- Player/Camera Controls --
    omBindCommand(COM_MOUSELEFT,	"HX")
    omBindCommand(COM_MOUSERIGHT, "HX")
    omBindCommand(COM_MLOOKUP,	"HY")
    omBindCommand(COM_MLOOKDOWN,	"HY")

    omBindCommand(COM_LOOKUP,	    "poop")
    omBindCommand(COM_LOOKDOWN,	"poop")

    omBindCommand(COM_FORWARD,	"UP")
    omBindCommand(COM_BACKWARD,	"DOWN")

    omBindCommand(COM_STRAFELEFT, "TLEFT")
    omBindCommand(COM_STRAFERIGHT,"TRIGHT")
    omBindCommand(COM_KBLEFT,		"LEFT")
    omBindCommand(COM_KBRIGHT,	"RIGHT")


    omBindCommand(COM_KJUMP,		"Y")
    omBindCommand(COM_CHUTE,		"Y")
    omBindCommand(COM_SHOOT,		"X")
    omBindCommand(COM_JET,		"A")
end

function c3()
    -- Player/Camera Controls --
    omBindCommand(COM_MOUSELEFT,	"HX")
    omBindCommand(COM_MOUSERIGHT, "HX")

    omBindCommand(COM_MLOOKUP,	"poop")
    omBindCommand(COM_MLOOKDOWN,	"poop")

    omBindCommand(COM_LOOKUP,	    "UP")
    omBindCommand(COM_LOOKDOWN,	"DOWN")

    omBindCommand(COM_FORWARD,	"HY")
    omBindCommand(COM_BACKWARD,	"HY")

    omBindCommand(COM_STRAFELEFT, "TLEFT")
    omBindCommand(COM_STRAFERIGHT,"TRIGHT")

    omBindCommand(COM_KJUMP,		"Y")
    omBindCommand(COM_CHUTE,		"Y")
    omBindCommand(COM_SHOOT,		"X")
    omBindCommand(COM_JET,		"A")
end


screenshotnum = 0
comfuncs.fkey[COM_SCREENSHOT] = function()
    local s = format("screen%d.tga",screenshotnum);
    chScreenShot(s);
    screenshotnum=screenshotnum+1;
end



--------------------------------------------------------------------------------
--  PrintAllLuaGlobals
--------------------------------------------------------------------------------
--  Prints all of the global LUA symbols to a debug file.
--------------------------------------------------------------------------------
function PrintAllLuaGlobals()
    chDebugOpen('c:\symbols.c')
    chDebugString('-----------------------------')
    local n,v = nextvar(nil)
    while (n) do
        if ((type(v) == "table") or (type(v) == "userdata")) then
            chDebugString(n)
        end
        n,v = nextvar(n)
    end
    chDebugString('-----------------------------')
    chDebugClose()
end






--------------------------------------------------------------------------------
--
--  Debug Menus
--
--------------------------------------------------------------------------------

--------------------------------------------------------------------
-- Debug
---------------------------------------------------------------------

menu.debug = mdkCreateMenu(menu.defx, menu.defy, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1)

item = mdkCreateMenuItem(menu.debug, "God Mode")
item.Select = function(self)
    GodDebugToggle()
end

item = mdkCreateMenuItem(menu.debug, "Spawn Object")
item.Select = function(self)
    menu.SwitchDlg('spawn')
end

item = mdkCreateMenuItem(menu.debug, "Spawn Doctor Item")
item.Select = function(self)
    menu.SwitchDlg('docitem')
end

item = mdkCreateMenuItem(menu.debug, "Warp To Point")
item.Select = function(self)
    menu.SwitchDlg('warp')
end

item = mdkCreateMenuItem(menu.debug, "Play Movie")
item.Select = function(self)
    playdemo = nil
    BuildMovieMenu()
    gamecontrol.showmenu = 1
    newconscheme = "menu"
    menu.SwitchDlg("movie")
end

item = mdkCreateMenuItem(menu.debug, "Render Options")
item.Select = function(self)
    UpdateRenderOptionsMenu()
    menu.SwitchDlg('render')
end

item = mdkCreateMenuItem(menu.debug, "Toggle Bars")
item.Select = function(self)
    scene = mdkGetScene()
    if scene.showbars==1 then
        scene.showbars=0
    else
        scene.showbars=1
    end
end

item = mdkCreateMenuItem(menu.debug, "Toggle Status")
item.Select = function(self)
    scene = mdkGetScene()
    if scene.showstatus==1 then
        scene.showstatus=0
    else
        scene.showstatus=1
    end
end

item = mdkCreateMenuItem(menu.debug, "Varview")
item.Select = function(self)
    if (debug) then
        gamecontrol.showvarview = 1
        gamecontrol.showmenu = 0
        newconscheme = "varview"
        MakeVarViewMenu()
    end
end

item = mdkCreateMenuItem(menu.debug, "Switch Player Character")
item.Select = function(self)
    menu.SwitchDlg('switchcharacter')
end

item = mdkCreateMenuItem(menu.debug, "Spawn Character")
item.Select = function(self)
    menu.SwitchDlg('spawnchar')
end

item = mdkCreateMenuItem(menu.debug, "Show Scene Graph")
item.Select = function(self)
    if (showscenegraph==1) then
        showscenegraph = 0
    else
        showscenegraph = 1
    end
end

item = mdkCreateMenuItem(menu.debug, "Record Demo")
item.Select = function(self)
    recorddemo = 1
    menu.SwitchDlg('debugload')
end

item = mdkCreateMenuItem(menu.debug, "Play Demo")
item.Select = function(self)
    playdemo = 2
    menu.SwitchDlg('debugload')
end

item = mdkCreateMenuItem(menu.debug, "Load Game")
item.Select = function(self)
    playdemo = nil
    menu.SwitchDlg("debugload")
end


numobj=0

--------------------------------------------------------------------
-- Render Options
---------------------------------------------------------------------

renderoptions=omGetRenderDebugOptions()

function UpdateRenderOptionsMenu()

    if(renderoptions.useasm~=renderoptions.xasm) then
        --lua menu needs to be updated
        if(renderoptions.useasm==1) then
            renderoptions.xasm=1
            mdkSetMenuItemText(renderoptions.asmitem,"x Assembly")
        else
            renderoptions.xasm=0
            mdkSetMenuItemText(renderoptions.asmitem,"  Assembly")
        end     

    end
    
    if(renderoptions.clipped~=renderoptions.xclipped) then
        --lua menu needs to be updated
        if(renderoptions.clipped==1) then
            renderoptions.xclipped=1
            mdkSetMenuItemText(renderoptions.clippeditem,"x clipped")
        else
            renderoptions.xclipped=0
            mdkSetMenuItemText(renderoptions.clippeditem,"  clipped")
        end     

    end

    if(renderoptions.staticplh~=renderoptions.xstaticplh) then
        --lua menu needs to be updated
        if(renderoptions.staticplh==1) then
            renderoptions.xstaticplh=1
            mdkSetMenuItemText(renderoptions.staticplhitem,"x staticplh")
        else
            renderoptions.xstaticplh=0
            mdkSetMenuItemText(renderoptions.staticplhitem,"  staticplh")
        end     

    end

    if(renderoptions.dynamicplh~=renderoptions.xdynamicplh) then
        --lua menu needs to be updated
        if(renderoptions.dynamicplh==1) then
            renderoptions.xdynamicplh=1
            mdkSetMenuItemText(renderoptions.dynamicplhitem,"x dynamicplh")
        else
            renderoptions.xdynamicplh=0
            mdkSetMenuItemText(renderoptions.dynamicplhitem,"  dynamicplh")
        end     

    end

    if(renderoptions.sml~=renderoptions.xsml) then
        --lua menu needs to be updated
        if(renderoptions.sml==1) then
            renderoptions.xsml=1
            mdkSetMenuItemText(renderoptions.smlitem,"x sml")
        else
            renderoptions.xsml=0
            mdkSetMenuItemText(renderoptions.smlitem,"  sml")
        end     

    end

    if(renderoptions.large~=renderoptions.xlarge) then
        --lua menu needs to be updated
        if(renderoptions.large==1) then
            renderoptions.xlarge=1
            mdkSetMenuItemText(renderoptions.largeitem,"x large")
        else
            renderoptions.xlarge=0
            mdkSetMenuItemText(renderoptions.largeitem,"  large")
        end     

    end

    if(renderoptions.lit~=renderoptions.xlit) then
        --lua menu needs to be updated
        if(renderoptions.lit==1) then
            renderoptions.xlit=1
            mdkSetMenuItemText(renderoptions.lititem,"x lit")
        else
            renderoptions.xlit=0
            mdkSetMenuItemText(renderoptions.lititem,"  lit")
        end     

    end

    if(renderoptions.selfillum~=renderoptions.xselfillum) then
        --lua menu needs to be updated
        if(renderoptions.selfillum==1) then
            renderoptions.xselfillum=1
            mdkSetMenuItemText(renderoptions.selfillumitem,"x selfillum")
        else
            renderoptions.xselfillum=0
            mdkSetMenuItemText(renderoptions.selfillumitem,"  selfillum")
        end     

    end

    if(renderoptions.doublesided~=renderoptions.xdoublesided) then
        --lua menu needs to be updated
        if(renderoptions.doublesided==1) then
            renderoptions.xdoublesided=1
            mdkSetMenuItemText(renderoptions.doublesideditem,"x doublesided")
        else
            renderoptions.xdoublesided=0
            mdkSetMenuItemText(renderoptions.doublesideditem,"  doublesided")
        end     

    end

    if(renderoptions.singlesided~=renderoptions.xsinglesided) then
        --lua menu needs to be updated
        if(renderoptions.singlesided==1) then
            renderoptions.xsinglesided=1
            mdkSetMenuItemText(renderoptions.singlesideditem,"x singlesided")
        else
            renderoptions.xsinglesided=0
            mdkSetMenuItemText(renderoptions.singlesideditem,"  singlesided")
        end     

    end

    if(renderoptions.perspective~=renderoptions.xperspective) then
        --lua menu needs to be updated
        if(renderoptions.perspective==1) then
            renderoptions.xperspective=1
            mdkSetMenuItemText(renderoptions.perspectiveitem,"x perspective")
        else
            renderoptions.xperspective=0
            mdkSetMenuItemText(renderoptions.perspectiveitem,"  perspective")
        end     

    end

    if(renderoptions.ortho~=renderoptions.xortho) then
        --lua menu needs to be updated
        if(renderoptions.ortho==1) then
            renderoptions.xortho=1
            mdkSetMenuItemText(renderoptions.orthoitem,"x ortho")
        else
            renderoptions.xortho=0
            mdkSetMenuItemText(renderoptions.orthoitem,"  ortho")
        end     

    end

    if(renderoptions.shadows~=renderoptions.xshadows) then
        --lua menu needs to be updated
        if(renderoptions.shadows==1) then
            renderoptions.xshadows=1
            mdkSetMenuItemText(renderoptions.shadowsitem,"x shadows")
        else
            renderoptions.xshadows=0
            mdkSetMenuItemText(renderoptions.shadowsitem,"  shadows")
        end     

    end

end


menu.render = mdkCreateMenu(0.4, 0.1, menu.defw, menu.defh, 0, JUSTIFY_LEFT, 1)

renderoptions.asmitem = mdkCreateMenuItem(menu.render, "  Assembly")
renderoptions.asmitem.Select = function(self)
    --Check status

    if(renderoptions.useasm==1) then
        renderoptions.useasm=0
        renderoptions.xasm=0
        mdkSetMenuItemText(renderoptions.asmitem,"  Assembly")
        --print("Assembly disabled")
    else
        renderoptions.useasm=1
        renderoptions.xasm=1
        mdkSetMenuItemText(renderoptions.asmitem,"x Assembly")
        --print("Assembly enabled")
    end
    
end

renderoptions.clippeditem = mdkCreateMenuItem(menu.render, "  clipped")
renderoptions.clippeditem.Select = function(self)
    --Check status

    if(renderoptions.clipped==1) then
        renderoptions.clipped=0
        renderoptions.xclipped=0
        mdkSetMenuItemText(renderoptions.clippeditem,"  clipped")
        --print("clipped disabled")
    else
        renderoptions.clipped=1
        renderoptions.xclipped=1
        mdkSetMenuItemText(renderoptions.clippeditem,"x clipped")
        --print("clipped enabled")
    end
    
end

renderoptions.staticplhitem = mdkCreateMenuItem(menu.render, "staticplh")
renderoptions.staticplhitem.Select = function(self)
    if(renderoptions.staticplh==1) then
        renderoptions.staticplh=0
        renderoptions.xstaticplh=0
        mdkSetMenuItemText(renderoptions.staticplhitem,"  staticplh")
        --print("staticplh disabled")
    else
        renderoptions.staticplh=1
        renderoptions.xstaticplh=1
        mdkSetMenuItemText(renderoptions.staticplhitem,"x staticplh")
        --print("staticplh enabled")
    end
end
    
renderoptions.dynamicplhitem = mdkCreateMenuItem(menu.render, "dynamicplh")
renderoptions.dynamicplhitem.Select = function(self)
    if(renderoptions.dynamicplh==1) then
        renderoptions.dynamicplh=0
        renderoptions.xdynamicplh=0
        mdkSetMenuItemText(renderoptions.dynamicplhitem,"  dynamicplh")
        --print("dynamicplh disabled")
    else
        renderoptions.dynamicplh=1
        renderoptions.xdynamicplh=1
        mdkSetMenuItemText(renderoptions.dynamicplhitem,"x dynamicplh")
        --print("dynamicplh enabled")
    end
end

renderoptions.smlitem = mdkCreateMenuItem(menu.render, "sml")
renderoptions.smlitem.Select = function(self)
    if(renderoptions.sml==1) then
        renderoptions.sml=0
        renderoptions.xsml=0
        mdkSetMenuItemText(renderoptions.smlitem,"  sml")
        --print("sml disabled")
    else
        renderoptions.sml=1
        renderoptions.xsml=1
        mdkSetMenuItemText(renderoptions.smlitem,"x sml")
        --print("sml enabled")
    end
end

renderoptions.largeitem = mdkCreateMenuItem(menu.render, "large")
renderoptions.largeitem.Select = function(self)
    if(renderoptions.large==1) then
        renderoptions.large=0
        renderoptions.xlarge=0
        mdkSetMenuItemText(renderoptions.largeitem,"  large")
        --print("large disabled")
    else
        renderoptions.large=1
        renderoptions.xlarge=1
        mdkSetMenuItemText(renderoptions.largeitem,"x large")
        --print("large enabled")
    end
end

renderoptions.lititem = mdkCreateMenuItem(menu.render, "lit")
renderoptions.lititem.Select = function(self)
    if(renderoptions.lit==1) then
        renderoptions.lit=0
        renderoptions.xlit=0
        mdkSetMenuItemText(renderoptions.lititem,"  lit")
        --print("lit disabled")
    else
        renderoptions.lit=1
        renderoptions.xlit=1
        mdkSetMenuItemText(renderoptions.lititem,"x lit")
        --print("lit enabled")
    end
end

renderoptions.selfillumitem = mdkCreateMenuItem(menu.render, "selfillum")
renderoptions.selfillumitem.Select = function(self)
    if(renderoptions.selfillum==1) then
        renderoptions.selfillum=0
        renderoptions.xselfillum=0
        mdkSetMenuItemText(renderoptions.selfillumitem,"  selfillum")
        --print("selfillum disabled")
    else
        renderoptions.selfillum=1
        renderoptions.xselfillum=1
        mdkSetMenuItemText(renderoptions.selfillumitem,"x selfillum")
        --print("selfillum enabled")
    end
end

renderoptions.doublesideditem = mdkCreateMenuItem(menu.render, "doublesided")
renderoptions.doublesideditem.Select = function(self)
    if(renderoptions.doublesided==1) then
        renderoptions.doublesided=0
        renderoptions.xdoublesided=0
        mdkSetMenuItemText(renderoptions.doublesideditem,"  doublesided")
        --print("doublesided disabled")
    else
        renderoptions.doublesided=1
        renderoptions.xdoublesided=1
        mdkSetMenuItemText(renderoptions.doublesideditem,"x doublesided")
        --print("doublesided enabled")
    end
end

renderoptions.singlesideditem = mdkCreateMenuItem(menu.render, "singlesided")
renderoptions.singlesideditem.Select = function(self)
    if(renderoptions.singlesided==1) then
        renderoptions.singlesided=0
        renderoptions.xsinglesided=0
        mdkSetMenuItemText(renderoptions.singlesideditem,"  singlesided")
        --print("singlesided disabled")
    else
        renderoptions.singlesided=1
        renderoptions.xsinglesided=1
        mdkSetMenuItemText(renderoptions.singlesideditem,"x singlesided")
        --print("singlesided enabled")
    end
end

renderoptions.perspectiveitem = mdkCreateMenuItem(menu.render, "perspective")
renderoptions.perspectiveitem.Select = function(self)
    if(renderoptions.perspective==1) then
        renderoptions.perspective=0
        renderoptions.xperspective=0
        mdkSetMenuItemText(renderoptions.perspectiveitem,"  perspective")
        --print("perspective disabled")
    else
        renderoptions.perspective=1
        renderoptions.xperspective=1
        mdkSetMenuItemText(renderoptions.perspectiveitem,"x perspective")
        --print("perspective enabled")
    end
end

renderoptions.orthoitem = mdkCreateMenuItem(menu.render, "ortho")
renderoptions.orthoitem.Select = function(self)
    if(renderoptions.ortho==1) then
        renderoptions.ortho=0
        renderoptions.xortho=0
        mdkSetMenuItemText(renderoptions.orthoitem,"  ortho")
        --print("ortho disabled")
    else
        renderoptions.ortho=1
        renderoptions.xortho=1
        mdkSetMenuItemText(renderoptions.orthoitem,"x ortho")
        --print("ortho enabled")
    end
end

renderoptions.shadowsitem = mdkCreateMenuItem(menu.render, "shadows")
renderoptions.shadowsitem.Select = function(self)
    if(renderoptions.shadows==1) then
        renderoptions.shadows=0
        renderoptions.xshadows=0
        mdkSetMenuItemText(renderoptions.shadowsitem,"  shadows")
        --print("shadows disabled")
    else
        renderoptions.shadows=1
        renderoptions.xshadows=1
        mdkSetMenuItemText(renderoptions.shadowsitem,"x shadows")
        --print("shadows enabled")
    end
end
--------------------------------------------------------------------
-- Switch Character
---------------------------------------------------------------------

menu.switchcharacter = mdkCreateMenu(menu.defx, 0.04, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1)

switchcharacter = function(self)

    local oldbob = mdkGetPlayerGob()
    local camera = mdkGetCameraGob()

    if (self.id == OBJ_MAX) then
        omGobDelete(camera)
        CreateMax()
    elseif (self.id == OBJ_DOC) then
        omGobDelete(camera)
        CreateDoctor()
    elseif (self.id == OBJ_KURT) then
        omGobDelete(camera)
        CreateKurt()
    elseif (self.id == OBJ_HYDE) then
        omGobDelete(camera)
        CreateDoctor()
        bob = hyde
        mdkSwitchPlayMode(PLAYMODE_HYDE)
    else
        bob = mdkCreateObjectLua("bob", self.id, scene, nil, nil, 0,0,0, 1,0,0,0, nil,0,0,0,0)

        mdkSetPlayModeGobs(PLAYMODE_WALKER, bob, nil)
        mdkSwitchPlayMode(PLAYMODE_WALKER)

        bob.OnUpdate = nil
        StopScript(bob)
    end

    if (oldbob) then
        bob.position = oldbob.position
        omGobDelete(oldbob)
    end
end

function shit2(name, num, id)
 local item = mdkCreateMenuItem(menu.switchcharacter, name)
 item.Select = switchcharacter;
 item.id = id
end

shit2("max",                0,  OBJ_MAX)
shit2("doc",                1,  OBJ_DOC)
shit2("kurt",               2,  OBJ_KURT)
shit2("grunt",              3,  OBJ_GRUNT)
shit2("hoser",              4,  OBJ_HOSER)
shit2("bif",                5,  OBJ_BIF)
shit2("hans",               7,  OBJ_HANS)
shit2("samsmite",           8,  OBJ_SAMSMITE)
shit2("flaming samsmite",   9,  OBJ_FLAMINGSAMSMITE)
shit2("obsidian samsmite",  10, OBJ_OBSIDIANSAMSMITE)
shit2("conehead",           11, OBJ_CONEHEAD)
shit2("doganboy",           13, OBJ_DOGANBOY)
shit2("ultra doganboy",     15, OBJ_ULTRADOGANBOY)
shit2("birdbrain1",         16, OBJ_BIRDBRAIN1)
shit2("shwang",             17, OBJ_SHWANG)
shit2("bfb",                18, OBJ_BFB)
shit2("badmax",             20, OBJ_BADMAX)
shit2("hyde",               21, OBJ_HYDE)
shit2("poopsy",             22, OBJ_POOPSY)
shit2("zizzy",              23, OBJ_ZIZZY)
shit2("inviso-grunt",       24, OBJ_INVISOGRUNT)

--------------------------------------------------------------------
-- Spawn Object
---------------------------------------------------------------------
menu.spawn = mdkCreateMenu(menu.defx, 0.03, menu.defw, 0.03, 0, JUSTIFY_CENTER, 1)

spawnselect = function(self)
    name = format("object%d",numobj);
    numobj=numobj+1;
    make(name,self.objid);
end

function shit(name, id)
 local item = mdkCreateMenuItem(menu.spawn, name)
 item.Select = spawnselect;
 item.objid = id
end

shit("magnum",              OBJ_MAGNUM)
shit("uzi",                 OBJ_UZI)
shit("gatgun",              OBJ_GATGUN)
shit("laser gatgun",        OBJ_LASERCANNON)
shit("shotgun",             OBJ_SHOTGUN)
shit("guidedrocket",        OBJ_GUIDEDROCKET)
shit("carbattery",          OBJ_CARBATTERY)
shit("doublea",             OBJ_DOUBLEA)
shit("jetpack",             OBJ_JETPACK)
shit("atomic jetpack",      OBJ_ATOMICJETPACK)
shit("dummydecoy",          OBJ_DECOYITEM)
shit("grenade",             OBJ_GRENADEITEM)
shit("blackhole",           OBJ_BLACKHOLE)
shit("cloak",               OBJ_CLOAK)
shit("apple",               OBJ_APPLE)
shit("ham",                 OBJ_HAM)
shit("snipergrenade",       OBJ_SNIPERGRENADEITEM)
shit("sniperhomebullet",    OBJ_SNIPERHOMEBULLETITEM)
shit("snipermortar",        OBJ_SNIPERMORTARITEM)
shit("sniperbounce",        OBJ_SNIPERBOUNCEITEM)
shit("snipershield",        OBJ_SNIPERSHIELD)
shit("refueller",           OBJ_REFUELLER)
shit("super chaingun",      OBJ_SUPERCHAINGUN)
shit("fireball chaingun",   OBJ_FIREBALLCHAINGUN)

--------------------------------------------------------------------
-- Spawn Doctor Object
---------------------------------------------------------------------
menu.docitem = mdkCreateMenu(menu.defx, 0.03, menu.defw, 0.03, 0, JUSTIFY_CENTER, 1)

docitemselect = function(self)
    name = format("object%d",numobj);
    numobj=numobj+1;
    make(name,self.objid);
end

function shit(name, num, id)
 local item = mdkCreateMenuItem(menu.docitem, name)
 item.Select = spawnselect;
 item.objid = id
end

shit("lighter",         0, OBJ_LIGHTER)
shit("loaf",            1, OBJ_LOAF)
shit("baguette",        2, OBJ_BAGUETTE)
shit("pumpernickel",    3, OBJ_PUMPERNICKEL)
shit("toaster",         4, OBJ_TOASTER)
shit("booze",           5, OBJ_BOOZE)
shit("ducttape",        6, OBJ_DUCTTAPE)
shit("fishbowl",        7, OBJ_FISHBOWL)
shit("empty fishbowl",  8, OBJ_EMPTYFISHBOWL)
shit("plutonium",       9, OBJ_PLUTONIUM)
shit("magnet",          10, OBJ_MAGNET)
shit("pop",             11, OBJ_POP)
shit("leaf blower",     12, OBJ_LEAFBLOWER)
shit("atomic toaster",  13, OBJ_ATOMICTOASTER)
shit("molotov",         14, OBJ_MOLOTOVITEM)
shit("towels",          15, OBJ_TOWELS)
shit("ladder",          16, OBJ_LADDER)
shit("pipes",           17, OBJ_PIPES)
shit("cord",            18, OBJ_CORD)
shit("handdryer",       19, OBJ_HANDDRYER)
shit("L9 dimensional destablizer", 20, OBJ_DIMDES)
shit("L9 kurt's coordinates",      21, OBJ_KURTCOORD)
shit("L9 positronic doohickey",    22, OBJ_POSDOO)


--------------------------------------------------------------------
-- Spawn Character
---------------------------------------------------------------------
menu.spawnchar = mdkCreateMenu(menu.defx, 0.04, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1)

spawncharselect = function(self)
    name = format("object%d",numobj)
    numobj=numobj+1
    if (self.objid==OBJ_CONEHEADCIV1) then
        make(name,self.objid+random(5)-1)
    elseif (self.objid==OBJ_SPHEREOFDOOM) then
        makesod(name,self.objid,self.name)
    else
        make(name,self.objid)
    end
end

function shit(name, num, id)
 local item = mdkCreateMenuItem(menu.spawnchar, name)
 item.Select = spawncharselect
 item.objid = id
 item.name = name
end

shit("max",                 0,  OBJ_MAX)
shit("doc",                 1,  OBJ_DOC)
shit("kurt",                2,  OBJ_KURT)
shit("grunt",               3,  OBJ_GRUNT)
shit("hoser",               4,  OBJ_HOSER)
shit("bif",                 5,  OBJ_BIF)
shit("hans",                7,  OBJ_HANS)
shit("samsmite",            8,  OBJ_SAMSMITE)
shit("flaming samsmite",    9,  OBJ_FLAMINGSAMSMITE)
shit("obsidian samsmite",   10, OBJ_OBSIDIANSAMSMITE)
shit("conehead",            11, OBJ_CONEHEAD)
shit("doganboy",            13, OBJ_DOGANBOY)
shit("ultra doganboy",      15, OBJ_ULTRADOGANBOY)
shit("birdbrain1",          16, OBJ_BIRDBRAIN1)
shit("shwang",              17, OBJ_SHWANG)
shit("bfb",                 18, OBJ_BFB)
shit("badmax",              20, OBJ_BADMAX)
shit("hyde",                21, OBJ_HYDE)
shit("poopsy",              22, OBJ_POOPSY)
shit("conehead civilian",   23, OBJ_CONEHEADCIV1)
shit("zizzy",               24, OBJ_ZIZZY)
shit("inviso-grunt",        25, OBJ_INVISOGRUNT)
shit("zizeye",                 26, OBJ_SPHEREOFDOOM)
shit("ultrasod",            27, OBJ_SPHEREOFDOOM)


--------------------------------------------------------------------
-- Warp Points Menu
---------------------------------------------------------------------
menu.warp = mdkCreateMenu(menu.defx, 0.04, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1)

function WarpTo(self)
    mdkStartLevel(self.level, self.warppoint)
    gamecontrol.showmenu = 0
    newconscheme = "game"
end

function StartWarpPoints(level)
    -- clear out old menu --
    local n = 0
    while (menu.warp.num and n < menu.warp.num) do
        menu.warp[n] = nil
        n = n + 1
    end
    mdkClearMenu(menu.warp)
    menu.warp.num = 0
    menu.warp.level = level
end

function AddWarpPoint(warppoint, name)
    local item = mdkCreateMenuItem(menu.warp, name)
    item.Select = WarpTo
    item.warppoint = warppoint
    item.level = menu.warp.level
    menu.warp[menu.warp.num] = item
    menu.warp.num = menu.warp.num + 1
end

function StopWarpPoints()
end


function makemax()
    make('a',OBJ_MAX)
    mdkMaxInitAI(a)
    mdkMaxAIGiveGun(a,OBJ_UZI)
    mdkMaxAIGiveGun(a,OBJ_UZI)
end

function fishme()
    mdkCreateObjectLua( "fish", OBJ_SUPERFISH, mdkGetScene(), nil, nil, 0,0,1000, 1,0,0,0, "fishy" )
    mdkSetPlayModeGobs(PLAYMODE_FISH, fish, nil)
    mdkSwitchPlayMode(PLAYMODE_FISH)
    mdkSetLuaEvent(fish, "OnUpdate", function(gob) mdkFishOnUpdate(gob) end)
    fish.position = bob.position
    fish.position.z = fish.position.z + 1.5
end


--------------------------------------------------------------------
-- Load
---------------------------------------------------------------------

menu.debugload = mdkCreateMenu(0.065, menu.defy, menu.defw, menu.defh, 0, -1, 1)

menu.debugload.checkpoints = {
    {
        { "1-1", 1,1 },
        { "1-2", 1,2 },
        { "1-3", 1,3 },
        { "1-4", 1,4 },
        { "1-5", 1,5 },
        { "1-6", 1,6 },
        { "1-7", 1,7 },
        { "1-8", 1,8 },
    },{
        { "2-1", 2,1 },
        { "2-2", 2,2 },
        { "2-3", 2,3 },
        { "2-4", 2,4 },
        { "2-5", 2,5 },
        { "2-6", 2,6 },
        { "2-7", 2,7 },
        { "2-8", 2,8 },
        { "2-9", 2,9 },
        { "2-10", 2,10 },
    },{
        { "3-1", 3,1 },
        { "3-2", 3,2 },
        { "3-3", 3,3 },
        { "3-4", 3,4 },
        { "3-5", 3,5 },
        { "3-6", 3,6 },
        { "3-6.5", 3,16 },
        { "3-7", 3,7 },
        { "3-8", 3,8 },
        { "3-9", 3,9 },
        { "3-10", 3,10 },
        { "3-11", 3,11 },
    },{
        { "4-1", 4,1 },
        { "4-2", 4,2 },
        { "4-3", 4,3 },
        { "4-4", 4,4 },
        { "4-5", 4,5 },
        { "4-6", 4,6 },
        { "4-7", 4,7 },
        { "4-8", 4,8 },
        { "4-9", 4,9 },        
        { "4-10", 4,10 },        
        { "4-11", 4,11 },        
		{ "4-12", 4,14 },        
    },{
        { "5-1", 5,1 },
        { "5-2", 5,2 },
        { "5-3", 5,3 },
        { "5-4", 5,4 },
        { "5-5", 5,5 },
        { "5-6", 5,6 },
        { "5-7", 5,7 },
        { "5-8", 5,8 },
        { "5-9", 5,9 },
        { "5-10", 5,10 },
    },{
        { "6-1", 6,1 },
        { "6-2", 6,2 },
        { "6-3", 6,3 },
        { "6-4", 6,4 },
        { "6-5", 6,5 },
        { "6-6", 6,6 },
        { "6-7", 6,7 },
    },{
        { "7-1", 7,1 },
        { "7-2", 7,2 },
        { "7-3", 7,3 },
        { "7-4", 7,4 },
        { "7-5", 7,5 },
        { "7-6", 7,6 },
        { "7-7", 7,7 },
        { "7-8", 7,8 },
    },{
        { "8-1", 8,1 },
        { "8-2", 8,2 },
        { "8-3", 8,3 },
        { "8-4", 8,4 },
        { "8-5", 8,5 },
        { "8-6", 8,6 },
        { "8-7", 8,7 },
    },{
        { "9-1", 9,1 },
        { "9-2", 9,3 },
        { "9-3", 9,4 },
        { "9-4", 9,5 },
        { "9-5", 9,6 },
        { "9-6", 9,7 },
        { "9-7", 9,8 },
        { "9-8", 9,11 },
        { "9-9", 9,12 },
    },{
        { "10-1", 10,1 },
        { "10-2", 10,2 },
        { "10-3", 10,3 },
        { "10-4", 10,4 },
        { "10-5", 10,5 },
        { "10-6", 10,6 },
        { "10-11", 10,11 },
    },{
        { "11-1", 11,1 },
        { "11-6", 11,6 },
        { "11-11", 11,11 },
    },{
        { "12-1", 12,1 },
        { "12-6", 12,6 },
        { "12-11", 12,11 },
    }
}

function BuildDebugLoadMenu()
    mdkClearMenu(menu.debugload)
    local ln,lv = next(menu.debugload.checkpoints, nil)
    local mi = 0
    menu.debugload.first = {}
    while (ln) do
        menu.debugload.first[ln] = mi
        local rn,rv = next(lv, nil)
        while (rn) do
            local item = mdkCreateMenuItem(menu.debugload, rv[1])
            mdkMenuItemSetPosition(item, (ln-1)*0.075, menu.defh*(rn-1))
            item.column = ln
            item.level = rv[2]
            item.room = rv[3]
            item.Select = function(self)
                mdkPauseGame(0)
                mdkNewGame(self.level, self.room)
                gamecontrol.showmenu = 0
                newconscheme = "game"
            end
            item.Inc = function(self)
                local nextlev = self.column+1
                if (menu.debugload.checkpoints[nextlev] == nil) then
                    nextlev = 1
                end
                mdkMenuSetHighlighted(menu.debugload, menu.debugload.first[nextlev])
            end
            item.Dec = function(self)
                local nextlev = self.column-1
                if (menu.debugload.checkpoints[nextlev] == nil) then
                    nextlev = 12
                end
                mdkMenuSetHighlighted(menu.debugload, menu.debugload.first[nextlev])
            end
            rn,rv = next(lv,rn)
            mi = mi + 1
        end
        ln,lv = next(menu.debugload.checkpoints, ln)
    end
end               

BuildDebugLoadMenu()
