Level = {}
Level["doscenegraph"] = 1
Level["file"] = "startscreen"
Level["scenegraph"] = {}
Level["scenegraph"]["sections"] = {}
Level["scenegraph"]["sections"]["preloaded"] = {}
Level["scenegraph"]["sections"]["preloaded"]["size"] = 590272
Level["scenegraph"]["sections"]["preloaded"][1] = "startscreen.mod"
Level["scenegraph"]["sections"]["preloaded"][2] = "ss_button00.mod"
Level["scenegraph"]["sections"]["preloaded"][3] = "ss_button01.mod"
Level["scenegraph"]["sections"]["preloaded"][4] = "ss_button02.mod"
Level["scenegraph"]["sections"]["preloaded"][5] = "ss_button03.mod"
Level["scenegraph"]["sections"]["preloaded"][6] = "optionbox1.tex"
Level["scenegraph"]["sections"]["preloaded"][7] = "textbox1.tex"
Level["scenegraph"]["sections"]["preloaded"][8] = "textbox2.tex"
Level["sounds"] = {}
Level["sounds"]["option_bar.wav"] = 0
Level["sounds"]["option_button.wav"] = 0
Level["sounds"]["option_select.wav"] = 0

if PreInitLevel()==1 then Level=nil return end

-- FUNCTIONS



Level.CheckVMUs = function()

$ifnot ginsu

    if (vmuselected == nil) then    -- lua global to make sure this is done once ever
        vmuselected = 1

        local total = 0
        local oom = 0

        local i = 0
        while (i < 8) do
            local hasvmu = chControlHasVMU(i)
            -- valid VMU --
            if (hasvmu >= mdkGetVMUSaveFileBlockSize()) then
                total = total + 1
            -- not enough space on VMU --
            elseif (hasvmu >= 0) then
                total = total + 1
                oom = oom + 1
            end
            i = i + 1
        end

        if (chControlGetActiveVMU() == 99) then
            -- All VMUs are out of memory --
            if (total > 0 and total == oom) then
                -- message: Not enough memory on VMU
                Level.popup = mdkMessageBoxCreate(0.1, 0.25, 0.8, 0.35, 241, 1)
                newconscheme = "popup"

            -- 1 nice valid VMU --
            elseif (total == 1) then
              local i = 0
              while (i < 8) do
                    -- valid VMU --
                  if (chControlHasVMU(i) >= 0) then
                      chControlSetActiveVMU(i)
                      mdkLoadGame()
                      mdkSaveGame(0)
                      i = 100
                  end
                  i = i + 1
              end

            -- More than 1 VMU, bring up menu --
            elseif (total > 1) then

            -- No VMUs --
            else
                -- message: No VMUs detected, game will not be saved.
                Level.popup = mdkMessageBoxCreate(0.1, 0.25, 0.8, 0.35, 242, 1)
                newconscheme = "popup"
            end
        end
    end

$end

end
----------------------------------------------------

Level.DisableLoadMenu = function()
    ss_button01.locked = 1
    omAnimPlay(ss_button01, ANIM_LOCK, ANIMFLAG_NOTRANS)
end
----------------------------------------------------

Level.doLoadGame = function()

    chSndSwitchMusic(-1)
    playdemo = nil
    BuildLoadMenu()
    gamecontrol.showmenu = 1
    newconscheme = "menu"
    menu.SwitchDlg("load")

    -- override default cancel function --
    menu.load.Cancel = function()
        gamecontrol.showmenu = 0
        newconscheme = "title"
        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        end
        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
        mdkHideCheckpointSnapshot()
        chSndSwitchMusic(1)
    end
end

----------------------------------------------------

Level.doNewGame = function()

    chSndSwitchMusic(-1)
    Level.freeze = 1
    omGobSetTimer(startscreen, 1.2)
    omAnimPlay(ss_button00, ANIM_CLOSE, ANIMFLAG_OVERLAY + ANIMFLAG_NOTRANS)
    omSceneFade(mdkGetScene(), 0, 0, 0, 1, 0.8, 10, 0, 1)
end

----------------------------------------------------

Level.doPlayMovie = function()

    chSndSwitchMusic(-1)
    playdemo = nil
    BuildMovieMenu()
    gamecontrol.showmenu = 1
    newconscheme = "menu"
    menu.SwitchDlg("movie")

    -- override default cancel function --
    menu.movie.Cancel = function()
        gamecontrol.showmenu = 0
        newconscheme = "title"
        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        end
        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
        chSndSwitchMusic(1)
    end
end

----------------------------------------------------

Level.Init = function(cp)
                    
    newconscheme = "title"

    chSndSwitchMusic(1)

    
    -- display MDK2 icon animation
    chControlAnimateImage(MDK2_ICON_ANIM, 4);

    comfuncs.title[COM_MENULEFT] = function() if (Level.Prev) then Level.Prev() end end
    comfuncs.title[COM_MENURIGHT] = function() if (Level.Next) then Level.Next() end end
    comfuncs.title[COM_MENUSELECT] = function() if (Level.Select) then Level.Select() end end
    comfuncs.title[COM_MENUSELECT2] = comfuncs.title[COM_MENUSELECT]

$if 1
    comfuncs.title[COM_DEBUGMENUTOG] = comfuncs.game[COM_DEBUGMENUTOG]
$end

    comfuncs.popup[COM_MENUSELECT] = function()
        newconscheme = "title"
        if (Level.popup) then
            mdkMessageBoxDestroy(Level.popup)
            Level.popup = nil
        end
    end
    comfuncs.popup[COM_MENUSELECT2] = comfuncs.popup[COM_MENUSELECT]

    mdkSwitchPlayMode(PLAYMODE_NONE)

    Level.selected = 0

    Level.buttongobs = {
        [0] = ss_button00,
        [1] = ss_button01,
        [2] = ss_button02,
        [3] = ss_button03,
    }

    Level.messagetext = {
        [0] = strings.newgame,
        [1] = strings.loadgame,
        [2] = strings.options,
$if ginsu
        [3] = strings.quit,
$else
        [3] = strings.playmovievc,
$end
    }

    Level.freeze = 1
    
    startscreen.analogtime = 0

    if exitgame then
        -- disable input --
        newconscheme = "poo"
        exitgame = nil
        mdkExitGame()

        -- disable animations on the start screen --
        local n,v = next(Level.buttongobs, nil)
        while (n) do
            omGobEnterStasis(v)
            n,v = next(Level.buttongobs, n)
        end
    end

    Level.CheckVMUs()
end
----------------------------------------------------

Level.Next = function()
    if (Level.freeze == nil) then

        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_LOCK, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DISABLED, ANIMFLAG_NOTRANS)
        end

        Level.selected = Level.selected + 1
        if (Level.selected > 3) then Level.selected = 0 end

        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        end

        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])

    end
end

----------------------------------------------------

Level.Prev = function()
    if (Level.freeze == nil) then

        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_LOCK, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DISABLED, ANIMFLAG_NOTRANS)
        end

        Level.selected = Level.selected - 1
        if (Level.selected < 0) then Level.selected = 3 end

        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        end

        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])

    end
end
----------------------------------------------------

Level.Select = function()
    if (Level.freeze == nil) then

        if (Level.buttongobs[Level.selected].locked) then

            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DAMAGE0, ANIMFLAG_NOTRANS)
            Level.freeze = 1
            Level.badselection = 1
            omGobSetTimer(startscreen, 0.8)
$if ginsu
            mdkMessageBoxSetText(Level.messagebox, strings.notavailableindemo)
$end

        else

            omAnimPlay(Level.buttongobs[Level.selected], ANIM_USE, ANIMFLAG_NOTRANS)

            -- new game --
            if (Level.selected == 0) then

                mdkMessageBoxSetText(Level.messagebox, 0)

                if (chControlGetActiveVMU() == 99) then
                    Level.freeze = 1
                    omGobSetTimer(startscreen, 1.2)
                    omAnimPlay(ss_button00, ANIM_CLOSE, ANIMFLAG_OVERLAY + ANIMFLAG_NOTRANS)
            	    omSceneFade(mdkGetScene(), 0, 0, 0, 1, 0.8, 10, 0, 1)
                    chSndSwitchMusic(-1)
                else
                    menu.vmu.whattodo = 1
                    BuildVMUMenu()
                    gamecontrol.showmenu = 1
                    newconscheme = "menu"
                    menu.SwitchDlg("vmu")
                    chControlSetActiveVMU(-1)
                end
            -- load game --
            elseif (Level.selected == 1) then

                mdkMessageBoxSetText(Level.messagebox, 0)

                if (chControlGetActiveVMU() == 99) then
                    playdemo = nil
                    BuildLoadMenu()
                    gamecontrol.showmenu = 1
                    newconscheme = "menu"
                    menu.SwitchDlg("load")

                    -- override default cancel function --
                    menu.load.Cancel = function()
                        gamecontrol.showmenu = 0
                        newconscheme = "title"
                        if (Level.buttongobs[Level.selected].locked) then
                            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
                        else
                            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
                        end
                        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
                        mdkHideCheckpointSnapshot()
                    end
                else
                    menu.vmu.whattodo = 2
                    BuildVMUMenu()
                    gamecontrol.showmenu = 1
                    newconscheme = "menu"
                    menu.SwitchDlg("vmu")
                    chControlSetActiveVMU(-1)
                end

            -- options --
            elseif (Level.selected == 2) then

                gamecontrol.showmenu = 1
                newconscheme = "menu"
                BuildOptionsMenu()
                menu.SwitchDlg("options")

                mdkMessageBoxSetText(Level.messagebox, 0)

                menu.options.Cancel = function()
                    mdkSaveGame(0)
                    gamecontrol.showmenu = 0
                    newconscheme = "title"
                    if (Level.buttongobs[Level.selected].locked) then
                        omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
                    else
                        omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
                    end
                    mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
                end

            -- quit / play movie --
            elseif (Level.selected == 3) then

                gamecontrol.showmenu = 1
                newconscheme = "menu"
                menu.SwitchDlg("moviecredits")
                mdkMessageBoxSetText(Level.messagebox, 0)

                menu.moviecredits.Cancel = function()
                    gamecontrol.showmenu = 0
                    newconscheme = "title"
                    if (Level.buttongobs[Level.selected].locked) then
                        omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
                    else
                        omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
                    end
                    mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
                end

            end

        end
    end
end

----------------------------------------------------

startscreen.OnTimer = function(gob)

    if (Level.badselection) then

        Level.freeze = nil
        Level.badselection = nil
        omAnimStop(Level.buttongobs[Level.selected], ANIM_DAMAGE0, ANIMFLAG_NOTRANS)
        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])

    else

        -- new game --
        if (Level.selected == 0) then

            mdkNewGame(1,9)
            newconscheme = "game"

        -- load game --
        elseif (Level.selected == 1) then

        -- playmovie --
        elseif (Level.selected == 2) then

        -- quit --
        elseif (Level.selected == 3) then
            -- disable input --
            newconscheme = "poo"
            mdkExitGame()

            mdkMessageBoxDestroy( Level.messagebox );
            Level.messagebox = -1
        end
    end
end

----------------------------------------------------

startscreen.OnUpdate = function(gob)
    if (gob.analogtime > 0) then
        gob.analogtime = gob.analogtime - chGetDeltaT()
    elseif (conscheme == "title") then
        local axis = omGetAxisValue(AXIS_MOUSELEFTRIGHT)
        if (axis < -0.01) then
            Level.Next()
            gob.analogtime = 0.2
        elseif (axis > 0.01) then
            Level.Prev()
            gob.analogtime = 0.2
        end
    end

    if (omGetCommandValue(COM_CHEATEN1) > 0 and omGetCommandValue(COM_CHEATEN2) > 0) then
        cheaten = 2
    else
        cheaten = nil
    end

end

----------------------------------------------------

ss_button00.OnAnimLoop = function(gob, anim)

    if (anim == ANIM_OPEN) then
        omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        Level.messagebox = mdkMessageBoxCreate(0.4, 0.85, 0.2, 0.1, Level.messagetext[Level.selected], 0)

        Level.freeze = nil
        if (chControlGetActiveVMU() == 99 and mdkGetNumberSavedPoints() == 0 and gamecontrol.showmenu == 0) then
            Level.DisableLoadMenu()
        end
    end
end

----------------------------------------------------
