---------------------------------------------------------------------
-- Menu Engine
---------------------------------------------------------------------

omMakeCommand(COM_PAUSE,        "ESC",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUUP,       "NUM 8",    CON_BUTTON_HELD, 0.1, 0.2)
omMakeCommand(COM_MENUDOWN,     "NUM 2",    CON_BUTTON_HELD, 0.1, 0.2)
omMakeCommand(COM_MENURIGHT,    "NUM 6",    CON_BUTTON_HELD, 0.1, 0.2)
omMakeCommand(COM_MENULEFT,     "NUM 4",    CON_BUTTON_HELD, 0.1, 0.2)
omMakeCommand(COM_MENUSELECT,   "ENTER",    CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUSELECT2,  "SPACE",    CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUCANCEL,   "ESC",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUCANCEL2,  "ESC",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUHIDECOMBO1, "W",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUHIDECOMBO2, "E",      CON_BUTTON_FALL, 0, 0)
omMakeCommand(COM_MENUHIDECOMBOUP1, "W",      CON_BUTTON_RISE, 0, 0)
omMakeCommand(COM_MENUHIDECOMBOUP2, "E",      CON_BUTTON_RISE, 0, 0)

function SetConScheme()
    if (newconscheme) then
        conscheme = newconscheme
        newconscheme = nil
    end
end

menu = {
    defx = 0.5,
    defy = 0.15,
    defw = 0.04,
    defh = 0.04,
}

function menu.SwitchDlg(name, zero)
    if (zero==nil) then zero=1 end
    mdkSetCurrentMenu(menu[name], zero)
    menu.current = name
end


comfuncs.menu[COM_MENUSELECT] = function()
    mdkMenuSelect()
end

comfuncs.menu[COM_MENUSELECT2] = comfuncs.menu[COM_MENUSELECT]


comfuncs.game[COM_PAUSE] = function()
    if (not Level.disablepausekey) then
        if (mdkDeathIsEnabled() == 1) then
            -- trying to pause the game during a death sequence cancels the death sequence --
            mdkDeathCancel()
        elseif (Level.movietocancel and not inminigame) then
            StopScript(Level.movietocancel)
            -- pause the game --
        elseif (not (ginsu and Level and Level.nopauseginsufade)) then
            gamecontrol.showmenu = 1
            if (omuClearConsole) then omuClearConsole() end
            newconscheme = "menu"
            BuildPauseMenu()
            menu.SwitchDlg('pause')
            mdkPauseGame(1)
            omSceneFade(mdkGetScene(), 0, 0, 0, 1, -1.0, 0.0, 1, 1)
        end
    end
end


comfuncs.menu[COM_MENUCANCEL] = function()
    if (menu[menu.current].Cancel) then
        menu[menu.current].Cancel()
    else
        if (Level.file == "startscreen") then   -- cough cough.
            mdkPauseGame(0)
            gamecontrol.showmenu = 0
            newconscheme = "title"
        else
            mdkPauseGame(0)
            gamecontrol.showmenu = 0
            newconscheme = "game"
        end
    end
end

comfuncs.menu[COM_MENUCANCEL2] = comfuncs.menu[COM_MENUCANCEL]


comfuncs.menu[COM_MENUHIDECOMBO1] = function()
    menuhideisdown1 = 1
    -- if both hide combination buttons are pressed, hide the pause menu --
    if (menu.current == "pause") and (menuhideisdown2) then
        gamecontrol.showmenu = 0
        newconscheme = "pause"
    end
end


comfuncs.menu[COM_MENUHIDECOMBO2] = function()
    menuhideisdown2 = 1
    -- if both hide combination buttons are pressed, hide the pause menu --
    if (menu.current == "pause") and (menuhideisdown1) then
        gamecontrol.showmenu = 0
        newconscheme = "pause"
    end
end

comfuncs.menu[COM_MENUHIDECOMBOUP1] = function()
    menuhideisdown1 = nil
end

comfuncs.menu[COM_MENUHIDECOMBOUP2] = function()
    menuhideisdown2 = nil
end

comfuncs.pause[COM_MENUHIDECOMBO1] = function()
    menuhideisdown1 = 1
    -- if both hide combination buttons are pressed, hide the pause menu --
    if (menu.current == "pause") and (menuhideisdown2) then
        gamecontrol.showmenu = 1
        newconscheme = "menu"
    end
end


comfuncs.pause[COM_MENUHIDECOMBO2] = function()
    menuhideisdown2 = 1
    -- if both hide combination buttons are pressed, hide the pause menu --
    if (menu.current == "pause") and (menuhideisdown1) then
        gamecontrol.showmenu = 1
        newconscheme = "menu"
    end
end

comfuncs.pause[COM_MENUHIDECOMBOUP1] = function()
    menuhideisdown1 = nil
end

comfuncs.pause[COM_MENUHIDECOMBOUP2] = function()
    menuhideisdown2 = nil
end

comfuncs.pause[COM_MENUSELECT] = function()
    mdkPauseGame(0)
    gamecontrol.showmenu = 0
    newconscheme = "game"
end

comfuncs.pause[COM_MENUSELECT2] = comfuncs.pause[COM_MENUSELECT]
comfuncs.pause[COM_MENUCANCEL] = comfuncs.pause[COM_MENUSELECT]
comfuncs.pause[COM_MENUCANCEL2] = comfuncs.pause[COM_MENUSELECT]


function HideMenu()
    gamecontrol.showmenu = 0
    newconscheme = "game"
end


function ShowMenu(name)
    gamecontrol.showmenu = 1
    newconscheme = "menu"
    menu.SwitchDlg(name)
end


--------------------------------------------------------------------
-- Pause
---------------------------------------------------------------------

menu.pause = mdkCreateMenu(0.5, 0.26, 0.06, 0.06, 0, JUSTIFY_CENTER, 1, strings.opt_pause)

function BuildPauseMenu()
    local item = mdkMenuGetItem(menu.pause, 1)

    -- only enable the load game item if there are saved checkpoints --
    if (mdkGetNumberSavedPoints() == 0) then
        mdkMenuItemEnable(item, 0)
    else
        mdkMenuItemEnable(item, 1)
    end
end

menu.pause.Cancel = function()
    mdkPauseGame(0)
    gamecontrol.showmenu = 0
    newconscheme = "game"
end

menu.pause.Update = function()
    if (omGetCommandValue(COM_CHEATEN1) > 0 and omGetCommandValue(COM_CHEATEN2) > 0) then
        cheaten = 1
    else
        cheaten = nil
    end
end

item = mdkCreateMenuItemW(menu.pause, strings.continue)
item.Select = function(self)               
    comfuncs.menu[COM_MENUCANCEL]()
end

item = mdkCreateMenuItemW(menu.pause, strings.loadgame)
item.Select = function(self)               
    playdemo = nil
    BuildLoadMenu()
    menu.SwitchDlg("load")
end
if (chControlGetActiveVMU() == -1) then
    mdkMenuItemEnable(item, 0)
else
    mdkMenuItemEnable(item, 1)
end

$if 1
item = mdkCreateMenuItemW(menu.pause, strings.cheats)
item.Select = function(self)
    menu.SwitchDlg("debug")
end
$end

item = mdkCreateMenuItemW(menu.pause, strings.options)
item.Select = function(self)
    BuildOptionsMenu()
    menu.SwitchDlg("options")
    menu.options.Cancel = function()
        mdkSaveGame(0)
        BuildPauseMenu()
        menu.SwitchDlg("pause")
    end
end

item = mdkCreateMenuItemW(menu.pause, strings.quit)
item.Select = function(self)
    menu.SwitchDlg("quitconfirm")
    mdkMenuSetHighlighted(menu.quitconfirm, 1)
end


---------------------------------------------------------------------
-- Load
---------------------------------------------------------------------

menu.load = mdkCreateMenu(0.065, 0.107, menu.defw, menu.defh * 1.1, 0, -1, 1)
menu.load.columnlen = 16
menu.load.fonth = menu.defh * 1.1

menu.load.checkpoints = {
    
    { 10,7, "10-A", strings.lv10cpa,"cp_l10_a" },

    { 9, 7,  "9-G", strings.lv9cpg, "cp_l9_g" },
    { 9, 12, "9-F", strings.lv9cpf, "cp_l9_f" },
    { 9, 10, "9-E", strings.lv9cpe, "cp_l9_e" },
    { 9, 9,  "9-D", strings.lv9cpd, "cp_l9_d" },
    { 9, 4,  "9-C", strings.lv9cpc, "cp_l9_c" },
    { 9, 2,  "9-B", strings.lv9cpb, "cp_l9_b" },
    { 9, 13, "9-A", strings.lv9cpa, "cp_l9_a" },
    
    { 8, 7,  "8-E", strings.lv8cpe, "cp_l8_e" },
    { 8, 6,  "8-D", strings.lv8cpd, "cp_l8_d" },
    { 8, 4,  "8-C", strings.lv8cpc, "cp_l8_c" },
    { 8, 2,  "8-B", strings.lv8cpb, "cp_l8_b" },
    { 8, 1,  "8-A", strings.lv8cpa, "cp_l8_a" },
    
    { 7, 8,  "7-E", strings.lv7cpe, "cp_l7_e" },
    { 7, 7,  "7-D", strings.lv7cpd, "cp_l7_d" },
    { 7, 10, "7-C", strings.lv7cpc, "cp_l7_c" },
    { 7, 9,  "7-B", strings.lv7cpb, "cp_l7_b" },
    { 7, 1,  "7-A", strings.lv7cpa, "cp_l7_a" },
    
    { 6, 7,  "6-E", strings.lv6cpe, "cp_l6_e" },
    { 6, 6,  "6-D", strings.lv6cpd, "cp_l6_d" },
    { 6, 5,  "6-C", strings.lv6cpc, "cp_l6_c" },
    { 6, 2,  "6-B", strings.lv6cpb, "cp_l6_b" },
    { 6, 1,  "6-A", strings.lv6cpa, "cp_l6_a" },
    
    { 5, 10, "5-E", strings.lv5cpe, "cp_l5_e" },
    { 5, 9,  "5-D", strings.lv5cpd, "cp_l5_d" },
    { 5, 6,  "5-C", strings.lv5cpc, "cp_l5_c" },
    { 5, 4,  "5-B", strings.lv5cpb, "cp_l5_b" },
    { 5, 11, "5-A", strings.lv5cpa, "cp_l5_a" },
    
    { 4, 14, "4-E", strings.lv4cpe, "cp_l4_e" },
    { 4, 11, "4-D", strings.lv4cpd, "cp_l4_d" },
    { 4, 9,  "4-C", strings.lv4cpc, "cp_l4_c" },
    { 4, 5,  "4-B", strings.lv4cpb, "cp_l4_b" },
    { 4, 1,  "4-A", strings.lv4cpa, "cp_l4_a" },

    { 3, 10, "3-F", strings.lv3cpf, "cp_l3_f" },
    { 3, 9,  "3-E", strings.lv3cpe, "cp_l3_e" },
    { 3, 7,  "3-D", strings.lv3cpd, "cp_l3_d" },
    { 3, 16, "3-C", strings.lv3cpc, "cp_l3_c" },
    { 3, 6,  "3-B", strings.lv3cpb, "cp_l3_b" },
    { 3, 15, "3-A", strings.lv3cpa, "cp_l3_a" },

    { 2, 10, "2-E", strings.lv2cpe, "cp_l2_e" },
    { 2, 9,  "2-D", strings.lv2cpd, "cp_l2_d" },
    { 2, 5,  "2-C", strings.lv2cpc, "cp_l2_c" },
    { 2, 3,  "2-B", strings.lv2cpb, "cp_l2_b" },
    { 2, 12, "2-A", strings.lv2cpa, "cp_l2_a" },

    { 1, 8,  "1-D", strings.lv1cpd, "cp_l1_d" },
    { 1, 7,  "1-C", strings.lv1cpc, "cp_l1_c" },
    { 1, 4,  "1-B", strings.lv1cpb, "cp_l1_b" },
    { 1, 11, "1-A", strings.lv1cpa, "cp_l1_a" },
}


------------------------------------------------------------------------
--  IsCheckpointCleared
------------------------------------------------------------------------
--  Returns non-nil iff the checkpoint in the given level and room has
--  been saved.
------------------------------------------------------------------------
function IsCheckpointCleared(level, room)
    local i = 0
    local l = mdkGetNumberSavedPoints()
    local found = nil

    while ((i < l) and (not found)) do
        if (mdkGetSavePointLevel(i) == level) and
           (mdkGetSavedPointCheckpoint(i) == room) then
            found = 1
        end
        i = i + 1
    end

    return found or showallcps
end


------------------------------------------------------------------------
--  AddLoadMenuItem
------------------------------------------------------------------------
--  Adds an item to the load menu, using the given checkpoint info
--  table.  If strid is not nil, it overrides the default item text.
------------------------------------------------------------------------
function AddLoadMenuItem(index, cpinfo, strid)
    local level = cpinfo[1]
    local room = cpinfo[2]
    local name = cpinfo[3]
    local desc = cpinfo[4]
    local screen = cpinfo[5]

    if (strid) then
        item = mdkCreateMenuItemW(menu.load, strid)
    else
        item = mdkCreateMenuItem(menu.load, name)
    end

    if (index > 0) then
        local col = floor((index - 1) / menu.load.columnlen)
        local row = (index - 1) - col * menu.load.columnlen
        mdkMenuItemSetPosition(item, col * 0.075, (row + 2) * menu.load.fonth)
    else
        mdkMenuItemSetPosition(item, 0, 0)
    end

    item.level = level
    item.room = room
    item.desc = desc
    item.screen = screen
    item.index = index

    item.Select = function(self)
        mdkHideCheckpointSnapshot()
        mdkPauseGame(0)
        mdkNewGame(self.level, self.room)
        gamecontrol.showmenu = 0
        newconscheme = "game"
    end

    item.Highlight = function(self)
        mdkShowCheckpointSnapshot(self.screen, self.desc)
    end

    item.Inc = function(self)
        if (self.index > 0) then
            local nextindex = self.index + menu.load.columnlen
            local nextitem = mdkMenuGetItem(menu.load, nextindex)
            if (nextitem) then
                mdkMenuSetHighlighted(menu.load, nextindex)
            end
        end
    end

    item.Dec = function(self)
        if (self.index > menu.load.columnlen) then
            local nextindex = self.index - menu.load.columnlen
            mdkMenuSetHighlighted(menu.load, nextindex)
        end
    end
end


------------------------------------------------------------------------
--  BuildLoadMenu
------------------------------------------------------------------------
--  Rebuilds the load menu, filling it with the list of saved
--  checkpoints.
------------------------------------------------------------------------
function BuildLoadMenu()
    mdkClearMenu(menu.load)
    local n, v, found, index

    menu.load.Cancel = function()
        mdkHideCheckpointSnapshot()
        mdkPauseGame(0)
        gamecontrol.showmenu = 0
        newconscheme = "game"
    end

    -- find last saved checkpoint and make it the "continue" option on the menu --
    found = nil
    n,v = next(menu.load.checkpoints, nil)
    while (v) and (not found) do
        local level = v[1]
        local room = v[2]

        if (IsCheckpointCleared(level, room)) then
            AddLoadMenuItem(0, v, strings.continue)
            found = 1
        end

        n,v = next(menu.load.checkpoints, n)
    end

    -- append all saved checkpoints to the menu --
    index = 1
    n,v = next(menu.load.checkpoints, nil)
    while (v) do
        local level = v[1]
        local room = v[2]

        if (IsCheckpointCleared(level, room)) then
            AddLoadMenuItem(index, v, nil)
            index = index + 1
        end

        n,v = next(menu.load.checkpoints, n)
    end

--    -- debug code: fill up the menu so we can position it nicely --
--    local i = 0
--    while (i < 1.5 * menu.load.columnlen) do
--        local n,v = next(menu.load.checkpoints, nil)
--        AddLoadMenuItem(i + 1, v, nil)
--        i = i + 1
--    end

end



---------------------------------------------------------------------
-- Movie
---------------------------------------------------------------------

menu.moviecredits = mdkCreateMenu(0.5, 0.3, 0.06, 0.06, 0, JUSTIFY_CENTER, 1, strings.movies)

item = mdkCreateMenuItemW(menu.moviecredits, strings.playmovie)
item.Select = function(self)
    if (chControlGetActiveVMU() == 99) then
        playdemo = nil
        BuildMovieMenu()
        gamecontrol.showmenu = 1
        newconscheme = "menu"
        menu.SwitchDlg("movie")

        -- override default cancel function --
        menu.movie.Cancel = function()
            gamecontrol.showmenu = 0
            newconscheme = "title"
            if (Level.buttongobs[Level.selected].locked) then
                omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
            else
                omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
            end
            mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
        end
    else
        menu.vmu.whattodo = 3
        BuildVMUMenu()
        gamecontrol.showmenu = 1
        newconscheme = "menu"
        menu.SwitchDlg("vmu")
        chControlSetActiveVMU(-1)
    end
end

item = mdkCreateMenuItemW(menu.moviecredits, strings.viewcredits)
item.Select = function(self)
    inmovieplayer = 1
    gamecontrol.showmenu = 0
    newconscheme = "game"
--    omGobEnterStasis(startscreen)
    mdkStartLevel(13,0)
end

item = mdkCreateMenuItemW(menu.moviecredits, strings.opt_ok)
item.Select = function(self)
    menu.moviecredits.Cancel()
end


$if 1
    menu.movie = mdkCreateMenu(0.35, 0.2, menu.defw, menu.defh*0.8, 0, -1, 1, strings.playmovie)
    menu.movie.columnlen = 18
    menu.movie.fonth = menu.defh * 0.8
$else
    menu.movie = mdkCreateMenu(0.35, 0.2, menu.defw, menu.defh*1.0, 0, -1, 1, strings.playmovie)
    menu.movie.columnlen = 13
    menu.movie.fonth = menu.defh * 1.0
$end

menu.movie.checkpoints = {

    --{ 0,0,  0,  "Credits" },
    
    { 1,9,  11, "1-Intro" },
    { 1,12, 11, "1-Intro B" },
    { 1,10, 8,  "1-End" },

    { 2,12, 12, "2-Intro" },
    { 2,13, 12, "2-Intro B" },
    { 2,14, 10, "2-End" },

    { 3,12, 15, "3-Intro" },
    { 3,13, 15, "3-Boss" },
    { 3,14, 10, "3-End" },

    { 4,12, 1,  "4-Intro" },
    { 4,15, 14, "4-Boss" },
    { 4,13, 14, "4-End" },

    { 5,11, 11, "5-Intro" },
    { 5,12, 10, "5-Boss" },
    { 5,13, 10, "5-End" },

    { 6,8,  1,  "6-Intro" },
    { 6,7,  7,  "6-Boss" },
    { 6,9,  7,  "6-End" },

    { 7,11, 1,  "7-Intro" },
    { 7,12, 8,  "7-End" },

    { 8,8,  1,  "8-Intro" },
    { 8,9,  7,  "8-Boss" },
    { 8,10, 7,  "8-End" },

    { 9,13, 13, "9-Intro" },
    { 9,14, 7,  "9-End" },

    { 10,7, 7,  "10-Intro" },

$if 1
    { 10,9, 1,  "10-Boss" },
    { 10,8, 1,  "10-End" },
    { 10,10,1,  "10-Comic" },
    { 11,4, 1,  "11-Boss" },
    { 11,3, 1,  "11-End" },
    { 11,2, 1,  "11-Comic" },
    { 12,4, 1,  "12-Boss" },
    { 12,3, 1,  "12-End" },
    { 12,2, 1,  "12-Comic" },
$end

}


function AddMovieMenuItem(index, cpinfo, strid, enabled)
    local level = cpinfo[1]
    local room = cpinfo[2]
    local name = cpinfo[4]

    if (strid) then
        item = mdkCreateMenuItemW(menu.movie, strid)
    else
        item = mdkCreateMenuItem(menu.movie, name)
    end

    if (index > 0) then
        if (index <= menu.movie.columnlen) then
            mdkMenuItemSetPosition(item, 0, (index - 1) * (menu.movie.fonth + 0.00))
        else
            mdkMenuItemSetPosition(item, 0.2, (index - 1 - menu.movie.columnlen) * (menu.movie.fonth + 0.00))
        end
    else
        mdkMenuItemSetPosition(item, 0, 0)
    end

    item.level = level
    item.room = room
    item.index = index

    if (not enabled) then
        mdkMenuItemEnable(item, 0)
    end

    item.Select = function(self)

        mdkPauseGame(0)
$ifnot nil
        inmovieplayer = 1       -- set global so we know to return to 0,0 when done
$end
        mdkNewGame(self.level, self.room)
        gamecontrol.showmenu = 0
        newconscheme = "game"
    end

    item.Inc = function(self)
        if (self.index > 0) then
            local nextindex = self.index + menu.movie.columnlen - 1
            local nextitem = mdkMenuGetItem(menu.movie, nextindex)
            if (nextitem) then
                mdkMenuSetHighlighted(menu.movie, nextindex)
            end
        end
    end

    item.Dec = function(self)
        if (self.index > menu.movie.columnlen) then
            local nextindex = self.index - menu.movie.columnlen - 1
            mdkMenuSetHighlighted(menu.movie, nextindex)
        end
    end
end


function BuildMovieMenu()

    mdkClearMenu(menu.movie)
    local n, v, index

    menu.movie.Cancel = function()
        mdkPauseGame(0)
        gamecontrol.showmenu = 0
        newconscheme = "game"
    end

    v = menu.movie.checkpoints[menu.movie.columnlen+1]

    -- append all saved checkpoints to the menu --
    index = 1
    n,v = next(menu.movie.checkpoints, nil)
    while (v) do
        local level = v[1]
        local room = v[3]
        local enabled = (level == 0) or (features) or (IsCheckpointCleared(level, room))

        AddMovieMenuItem(index, v, nil, enabled)
        index = index + 1

        n,v = next(menu.movie.checkpoints, n)
    end

end

                       
--------------------------------------------------------------------
-- VMU Selection
---------------------------------------------------------------------

menu.vmu = mdkCreateMenu(0.5, 0.2, 0.045, 0.045, 0.01, JUSTIFY_CENTER, 1, strings.vmumenunew)

menu.vmu.Cancel = function()
    gamecontrol.showmenu = 0
    newconscheme = "title"
    if (Level.buttongobs[Level.selected].locked) then
        omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
    else
        omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
    end
    mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
end

function BuildVMUMenu()
    mdkClearMenu(menu.vmu)
    local i = 0
    local item

    chStopBeep()

    if (menu.vmu.whattodo == 1) then
        mdkSetMenuTitle(menu.vmu,strings.vmumenunew) 
    elseif (menu.vmu.whattodo == 2 or menu.vmu.whattodo == 3) then
        mdkSetMenuTitle(menu.vmu,strings.vmumenuload) 
    end

    while (i < 8) do

        item = mdkCreateMenuItem(menu.vmu, "------")

        item.status = -2
        item.port = i

        item.Select = function(self)
            chControlSetActiveVMU(self.port)
            mdkLoadGame()
            mdkSaveGame(0)
            newconscheme = "title"
            gamecontrol.showmenu = 0
            if (menu.vmu.whattodo == 1) then
                Level.doNewGame()
            elseif (menu.vmu.whattodo == 2) then
                Level.doLoadGame()
            elseif (menu.vmu.whattodo == 3) then
                Level.doPlayMovie()
            end
        end

        menu.vmu[i] = item

        i = i + 1
    end

    if (menu.vmu.whattodo == 1) then
        item = mdkCreateMenuItemW(menu.vmu, strings.continuesave) 

        item.status = -2
        item.port = i

        item.Select = function(self)
            chControlSetActiveVMU(-1)
            BuildVMUConfirmMenu()
            menu.SwitchDlg("vmuconfirm")
        end
    end
end

menu.vmuconfirm = mdkCreateMenu(0.5, 0.2, 0.045, 0.045, 0.01, JUSTIFY_CENTER, 1, strings.vmuconfirm)

menu.vmuconfirm.Cancel = function()
    BuildVMUMenu()
    menu.SwitchDlg("vmu")
end

function BuildVMUConfirmMenu()
    mdkClearMenu(menu.vmuconfirm)
    local item
    
    item = mdkCreateMenuItemW(menu.vmuconfirm, strings.continue) 

    item.Select = function(self)
        newconscheme = "title"
        gamecontrol.showmenu = 0
        Level.doNewGame()
    end

    item = mdkCreateMenuItemW(menu.vmuconfirm, strings.opt_cancel) 

    item.Select = function(self)
        BuildVMUMenu()
        menu.SwitchDlg("vmu")
    end
end

menu.vmu.Update = function()
    local n,v,found
    local i = 0

    chStopBeep()

    if (menu.vmu.whattodo == 1) then
        mdkSetMenuTitle(menu.vmu,strings.vmumenunew) 
    elseif (menu.vmu.whattodo == 2 or menu.vmu.whattodo == 3) then
        mdkSetMenuTitle(menu.vmu,strings.vmumenuload) 
    end

    while (i < 8) do
        local item = menu.vmu[i]
        local hasVMU = chControlHasVMU(i)
        if (item.status ~= hasVMU) then
            local status = mdkVMUStatus(i)
            item.status = hasVMU
            item.oom = nil
            mdkMenuItemEnable(item, 1)

            -- bad save game --
            if (chGetVMUError() == 1) then
                mdkStringSetTagStrId(0, strings.badsavegame)
                mdkSetMenuItemTextW(item, vmuports[i+1])
                mdkMenuItemEnable(item, 0)
            -- no vmu --
            elseif (status == -2) then
                mdkStringSetTagStrId(0, strings.novmu)
                mdkSetMenuItemTextW(item, vmuports[i+1])
                mdkMenuItemEnable(item, 0)
            -- not enough memory on VMU --
            elseif (status == -1 and menu.vmu.whattodo == 1) then
                mdkStringSetTagStrId(0, strings.vmufull)
                mdkSetMenuItemTextW(item, vmuports[i+1])
                mdkMenuItemEnable(item, 0)
                item.oom = 1
            elseif (status == -1 and (menu.vmu.whattodo == 2 or menu.vmu.whattodo == 3)) then
                mdkStringSetTagStrId(0, strings.novmu)
                mdkSetMenuItemTextW(item, vmuports[i+1])
                mdkMenuItemEnable(item, 0)
                item.oom = 1
            -- no saved game --
            elseif (status == 0 and menu.vmu.whattodo == 1) then
                mdkStringSetTagStrId(0, strings.vmuempty)
                mdkSetMenuItemTextW(item, vmuports[i+1])
            elseif (status == 0 and (menu.vmu.whattodo == 2 or menu.vmu.whattodo == 3)) then
                mdkStringSetTagStrId(0, strings.novmu)
                mdkSetMenuItemTextW(item, vmuports[i+1])
                mdkMenuItemEnable(item, 0)    
            -- a saved game exists --
            else
                -- find last saved checkpoint
                found = nil
                n,v = next(menu.load.checkpoints, nil)
                while (v) and (not found) do
                    local level = v[1]
                    local room = v[2]
                    local string = v[4]

                    if (IsCheckpointCleared(level, room)) then
                        mdkStringSetTagStrId(0, string)
                        mdkSetMenuItemTextW(item, vmuports[i+1])
                        found = 1
                    end

                    n,v = next(menu.load.checkpoints, n)
                end
                if (menu.vmu.whattodo == 1) then
                    mdkMenuItemEnable(item, 0)    
                end
            end
        end
        i = i + 1
    end
    chControlSetActiveVMU(-1)
    mdkCreateEmptyGame()
end

vmuports = {
strings.porta0,
strings.porta1,
strings.portb0,
strings.portb1,
strings.portc0,
strings.portc1,
strings.portd0,
strings.portd1
}

function CancelMenuToStartScreen()
    gamecontrol.showmenu = 0
    newconscheme = "title"
    if (Level) then
        if (Level.buttongobs[Level.selected].locked) then
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_DOWN, ANIMFLAG_NOTRANS)
        else
            omAnimPlay(Level.buttongobs[Level.selected], ANIM_ENABLED, ANIMFLAG_NOTRANS)
        end
        mdkMessageBoxSetText(Level.messagebox, Level.messagetext[Level.selected])
    end
end

--------------------------------------------------------------------
-- Frequency Switch Confirmation
---------------------------------------------------------------------

menu.freqconfirm = mdkCreateMenu(menu.defx, 0.4, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1, strings.freqconfirm)

menu.freqconfirm.Cancel = function()
    menu.SwitchDlg("optgame")
end

item = mdkCreateMenuItemW(menu.freqconfirm, strings.yes)
item.Select = function()
    chVideoToggleMode()
    mdkMenuItemSetAutoSelectTime(menu.freqcorrect.pooitempoo, 5)
    menu.SwitchDlg("freqcorrect")
end

item = mdkCreateMenuItemW(menu.freqconfirm, strings.no)
item.Select = function()
    menu.SwitchDlg("optgame")
end


--------------------------------------------------------------------
-- Frequency Display Correct
---------------------------------------------------------------------

menu.freqcorrect = mdkCreateMenu(menu.defx, 0.4, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1, strings.freqcorrect)

menu.freqcorrect.Cancel = function()
    chVideoToggleMode()
    menu.SwitchDlg("optgame")
end

item = mdkCreateMenuItemW(menu.freqcorrect, strings.yes)
item.Select = function()
    menu.SwitchDlg("optgame")
end

item = mdkCreateMenuItemW(menu.freqcorrect, strings.no)
item.Select = function()
    menu.freqcorrect.Cancel()
end
menu.freqcorrect.pooitempoo = item


--------------------------------------------------------------------
-- Quit Game Confirmation
---------------------------------------------------------------------

menu.quitconfirm = mdkCreateMenu(menu.defx, 0.4, menu.defw, menu.defh, 0, JUSTIFY_CENTER, 1, strings.quitconfirm)

menu.quitconfirm.Cancel = function()
    menu.SwitchDlg("pause")
end

item = mdkCreateMenuItemW(menu.quitconfirm, strings.yes)
item.Select = function()
    mdkPauseGame(0)
    mdkStartLevel(0,0)
    gamecontrol.showmenu = 0
    newconscheme = "game"
    chSndSwitchMusic(-1)
    chControlSetActiveVMU(-1)
end

item = mdkCreateMenuItemW(menu.quitconfirm, strings.no)
item.Select = function()
    menu.SwitchDlg("pause")
end


-- load options menu --
dofile('options')
