
-------------------------------------------------------------------------
--	Script Interpreter
-------------------------------------------------------------------------

function ScriptUpdate(self)

	local dt = chGetDeltaT()
	local stack = self.stack

	if (stack and stack.paused==nil) then

		local script = stack.script
		local res = 1

        while (res ~= 0 and self.stack) do

		    local task = script[stack.nexttask]

		    if (task[1] == print) then
			    print(task[2][1])
			    res = 1

		    elseif (task[1]) then

                if (stack.global) then

				    --res = call(task[1], task[2])

$if 1
                    if (task[1] == omAnimPlay or task[1] == omAnimJustLooped or
                        task[1] == omGobEnterStasis or task[1] == omGobExitStasis) then
                        
                        if (task[2][1] == nil) then
                            print(format("invalid gob name on script command %d", stack.nexttask))
                            self.stack = nil
                            return
                        end
                    end

                    if (task[1] == omAnimPlay or task[1] == omAnimJustLooped) then
                        
                        if (task[2][2] == nil) then
                            print(format("invalid animation name on script command %d on gob %s", stack.nexttask, task[2][1].name))
                            self.stack = nil
                            return
                        end
                    end

                    if (task[1] == mdkDialogPanel and task[2][1] == nil) then
                        print(format("invalid string on script command %d", stack.nexttask))
                        self.stack = nil
                        return
                    end

                    if (task[1] == mdkDialogPanel and task[2][2] == nil) then
                        print(format("invalid portrait on script command %d string %d", stack.nexttask, task[2][1].name))
                        self.stack = nil
                        return
                    end
$end


				    if (task[2] == nil or task[2][1] == nil) then
					    res = task[1]()
				    elseif (task[2][2] == nil) then
					    res = task[1](task[2][1])
				    elseif (task[2][3] == nil) then
					    res = task[1](task[2][1], task[2][2])
				    elseif (task[2][4] == nil) then
					    res = task[1](task[2][1], task[2][2], task[2][3])
				    elseif (task[2][5] == nil) then
					    res = task[1](task[2][1], task[2][2], task[2][3], task[2][4])
				    elseif (task[2][6] == nil) then
					    res = task[1](task[2][1], task[2][2], task[2][3], task[2][4], task[2][5])
				    elseif (task[2][7] == nil) then
					    res = task[1](task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6])
				    elseif (task[2][8] == nil) then
					    res = task[1](task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6], task[2][7])
				    else
					    res = task[1](task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6], task[2][7], task[2][8])
				    end

                else

				    if (task[2] == nil or task[2][1] == nil) then
					    res = task[1](self)
				    elseif (task[2][2] == nil) then
					    res = task[1](self,task[2][1])
				    elseif (task[2][3] == nil) then
					    res = task[1](self,task[2][1], task[2][2])
				    elseif (task[2][4] == nil) then
					    res = task[1](self,task[2][1], task[2][2], task[2][3])
				    elseif (task[2][5] == nil) then
					    res = task[1](self,task[2][1], task[2][2], task[2][3], task[2][4])
				    elseif (task[2][6] == nil) then
					    res = task[1](self,task[2][1], task[2][2], task[2][3], task[2][4], task[2][5])
				    elseif (task[2][7] == nil) then
					    res = task[1](self,task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6])
				    elseif (task[2][8] == nil) then
					    res = task[1](self,task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6], task[2][7])
				    else
					    res = task[1](self,task[2][1], task[2][2], task[2][3], task[2][4], task[2][5], task[2][6], task[2][7], task[2][8])
				    end
                end

		    else
			    error(format("script function undefined: %s task %d", tostring(self.name), stack.nexttask))
		    end

		    if (res == nil or stack.skip == 1) then
			    res = 1
		    end

		    if (type(res) == "number") then

			    stack.nexttask = stack.nexttask + res
		    
			    if (script[stack.nexttask] == nil) then
				    
                    StopScript(self)
                    
                    --call a handy little event
                    if(self.OnStopScript) then self.OnStopScript(self) end
                    -- i believe that this will kill the current script, 
                    -- but next will run fine
                    res = 0
                    
			    end

		    else
			    error(format("script command returned: %s", type(res)))
		    end

        end

	end
	
end


function StartScript(self, sc)
	--local oldstack = self.stack	
	self.stack = {
		script = sc,
		--nextstack = oldstack,
		nexttask = 1,
		waittimer = 0,
		taskorder = 1,
	}
	mdkGobEnableScript(self)
	return 1
end

function StartGlobalScript(self, sc)
	StartScript(self, sc)
	self.stack.global = 1
end

function StartMovie(self, sc)
	StartScript(self, sc)
	self.stack.global = 1
	self.stack.movie = 1

    -- remember this movie for the abort movie key --
    Level.movietocancel = nil
    if (sc.Done) then
        Level.movietocancel = self
    end

    -- cancel any blackhole grenade that might be running --
    local player = mdkGetPlayerGob()
    if (player) and (mdkGetGobType(player) == OBJ_KURT) then
        mdkKurtAbortBlackhole(player)
    end
    if (player) and (mdkGetGobType(player) == OBJ_MAX) then
        mdkMaxAbortSloMo(player)
    end

end

function StopScript(self)

	if (self.stack) and (omGobIsStasis(self) == 0) then

        if (self.stack.movie) then

            if (not inmovieplayer) then

                -- check for minigame marker --            
                local script = self.stack.script
                local i = self.stack.nexttask
                while (script[i]) do
                    if (script[i][1] == MiniGameStart) then
                        self.stack.nexttask = i
                        return
                    end
                    i = i + 1
                end

            end

            Level.movietocancel = nil

            if (inmovieplayer) then

                -- movie played from the play movie menu --
                mdkNewGame(0,0)
                inmovieplayer = nil
                mdkDumpAllTempRes()

            elseif (self.stack.script.Done) then

                -- movie played from in the game --
                self.stack.script.Done()
                mdkDialogDestroy()
                mdkDumpAllTempRes()

            end

        end

		self.stack = nil
        mdkGobDisableScript(self)

	end

	return 0
     
end

function MiniGame()
end

function MiniGameStart()
    inminigame = 1
end

function MiniGameEnd()
    inminigame = nil
end

function PauseScript(self)
    self.stack.paused = 1
end

function ResumeScript(self)
    self.stack.paused = nil
end


function LoopScript(self)
	if (self.stack) then
		self.stack.nexttask = 1
	end
	return 0
end

function ScriptJumpCount(self, offset, times)
    if(self.stack) then
        if(self.jumptimes == nil) then
            self.jumptimes = times
        else
            self.jumptimes = self.jumptimes - 1
            if(self.jumptimes <= 0) then return 1
            else self.stack.nexttask = self.stack.nexttask + offset
            end
        end
    end
    return 0
end

function ScriptJumpIfNil(offset, gobtocheck)
    if(not gobtocheck) then
        return offset
    end
end

function ScriptJump(self, offset)
	if (self.stack) then
		self.stack.nexttask = self.stack.nexttask + offset
	end
	return 0
end

function IsScriptDone(self)
    return (self.stack == nil)
end


comfuncs.game[COM_ABORTMOVIE] = function()
    if (Level.movietocancel and not inminigame) then
        StopScript(Level.movietocancel)
    end
end


-------------------------------------------------------------------------
--	Script Commands
-------------------------------------------------------------------------

function Wait(self, time)
	if (self.waittimer == nil) then
		self.waittimer = time
	else
		self.waittimer = self.waittimer - chGetDeltaT()
		if (self.waittimer <= 0) then
			self.waittimer = nil
			return 1
		end
	end
	return 0
end

function WaitForAnim(self, anim)
	if (omAnimIsPlaying(self,anim)==0) then -- or omAnimJustLooped(self,anim)==1) then
		return 1
	else
		return 0
	end
end

function SpawnItem(pt, item)
	local gob = mdkCreateObjectLua("", item, scene, nil, nil, points[pt].x, points[pt].y, points[pt].z, 1,0,0,0, nil,0,0,0,0)
end

function SetVar(var, val)
    Level[var] = val
end



-------------------------------------------------------------------------
--	Common Bad Guy Scripts and Event Handlers
-------------------------------------------------------------------------

DefaultAIScripts = {

    [OBJ_DOGANBOY] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_ULTRADOGANBOY] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_BIRDBRAIN1] = {
        script = {{ mdkBirdbrainAttack }},
    },

    [OBJ_BIF] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_SAMSMITE] = {
        script = {{ mdkSamsmiteAttack }},
    },

    [OBJ_FLAMINGSAMSMITE] = {
        script = {{ mdkSamsmiteAttack }},
    },

    [OBJ_OBSIDIANSAMSMITE] = {
        script = {{ mdkSamsmiteAttack }},
    },

    [OBJ_CONEHEAD] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_HANS] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_POOPSY] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_HOSER] = {
        script = {{ mdkDoganboyAttack }},
    },

    [OBJ_GRUNT] = {
        script = {{ mdkDoganboyAttack }},
        OnDamage = mdkGruntOnDamage
    },

    [OBJ_INVISOGRUNT] = {
        script = {{ mdkDoganboyAttack }},
        OnDamage = mdkGruntOnDamage
    },

    [OBJ_CONEHEADCIV1] = {
        script = {{ mdkConeheadCivUpdate }},
        OnHear = mdkConeheadCivOnHear
    },

}

function SetDefaultWalkerEvents(gob, id)
    gob.OnDamage = DefaultWalkerOnDamage
    if (DefaultAIScripts[id] == nil) then
        --print(format("walker %d has no default script", id))
    else
        StartScript(gob, DefaultAIScripts[id].script)
        if (DefaultAIScripts[id].OnHear) then
            gob.OnHear = DefaultAIScripts[id].OnHear
        end
        if (DefaultAIScripts[id].OnDamage) then
            gob.OnDamage = DefaultAIScripts[id].OnDamage
        end
    end
end

function DefaultWalkerOnDamage(gob, shooter, damage, damagetype, partname)
    mdkWalkerDefaultOnDamage(gob, shooter, damage, damagetype, partname)
    mdkWalkerAlert(gob, 1)
end
